// copy van usmodel_hist_dsge_f19_7_71

var labobs robs pinfobs dy dc dinve dw  ewma epinfma  zcapf rkf kf pkf   
 cf invef yf labf wf rrf mc zcap rk k pk    
c inve y lab pinf w r a  b g qs  ms  spinf sw kpf kp dq x 
afactor bfactor gfactor qsfactor msfactor spinffactor swfactor
atilde btilde gtilde qstilde mstilde spinftilde swtilde f1 f2;

 
varexo ea eb eg  eqs  em  epinf ew eq ex;  
 
parameters curvw cgy curvp constelab constepinf constebeta cmaw cmap calfa 
czcap csadjcost ctou csigma chabb ccs cinvs cfc 
cindw cprobw cindp cprobp csigl clandaw 
crdpi crpi crdy cry crr 
crhoa crhoas crhob crhog crhols crhoqs crhoms crhopinf crhow  
ctrend cg 
crhox lambda_a lambda_b lambda_g lambda_qs lambda_ms lambda_spinf lambda_sw qtrend
lambda_a2 lambda_b2 lambda_g2 lambda_qs2 lambda_ms2 lambda_spinf2 lambda_sw2 Xi11 Xi12
phi11 phi12 phi21 phi22;


// fixed parameters
ctou=.025;
clandaw=1.5;
cg=0.18;
curvp=10;
curvw=10;

// estimated parameters initialisation

crhoa      = 0.9209;
crhob      = 0.5093;
crhog      = 0.9686;
crhoqs     = 0.6241;
crhoms     = 0.2993;
crhopinf   = 0.5204;
crhow      = 0.6744;
cmap       = 0.3817;
cmaw       = 0.4080;
csadjcost  = 6.2204;
csigma     = 1.2784;
chabb      = 0.6218;  
cprobw     = 0.7668;
csigl      = 2.1802;
cprobp     = 0.7780;
cindw      = 0.4353;
cindp      = 0.2668;
czcap      = 0.6509;
cfc        = 1.5101;
crpi       = 1.6532;
crr        = 0.8462;
cry        = 0.1369;
crdy       = 0.1682;
constepinf = 0.6096;
constebeta = 0.1513;
constelab  = 0.6659;
ctrend     = 0.4847;
cgy        = 0.4144;
calfa      = 0.1952;

sigma_ea   = 0.3716;
sigma_eb   = 0.1387;
sigma_eg   = 0.4092;
sigma_eqs  = 0.4076;
sigma_em   = 0.1195;
sigma_epinf= 0.1264;
sigma_ew   = 0.2236;
sigma_eq   = 1;
sigma_ex   = 0.01;
 
crhoas=1; 
crhoms=0;

lambda_a = 0;
lambda_b = 0;
lambda_g = 0;
lambda_sw = 0;
lambda_ms = 1;
lambda_spinf = 0;
lambda_qs = 0;

lambda_a2 = 0;
lambda_b2 = 0;
lambda_g2 = 0;
lambda_sw2 = 1;
lambda_ms2 = 0;
lambda_spinf2 = 0;
lambda_qs2 = 0;
qtrend = 0.6;
crhox = 0.8;

phi11 =0.8;
phi22 = 0.8;
Xi11 = -2.64571988083457e-006;
Xi12 = -1.45171659894066e-006;

model(linear); 

@#include "usmodel_stst.mod"

// flexible economy

	      0*(1-calfa)*atilde + 1*atilde =  calfa*rkf+(1-calfa)*(wf)  ;
	      zcapf =  (1/(czcap/(1-czcap)))* rkf  ;
	      rkf =  (wf)+labf-kf ;
	      kf =  kpf(-1)+zcapf ;
	      invef = (1/(1+cbetabar*cgamma))* (  invef(-1) + cbetabar*cgamma*invef(1)+(1/(cgamma^2*csadjcost))*pkf ) +qstilde ;
          pkf = -rrf-0*btilde+(1/((1-chabb/cgamma)/(csigma*(1+chabb/cgamma))))*btilde +(crk/(crk+(1-ctou)))*rkf(1) +  ((1-ctou)/(crk+(1-ctou)))*pkf(1) ;
	      cf = (chabb/cgamma)/(1+chabb/cgamma)*cf(-1) + (1/(1+chabb/cgamma))*cf(+1) +((csigma-1)*cwhlc/(csigma*(1+chabb/cgamma)))*(labf-labf(+1)) - (1-chabb/cgamma)/(csigma*(1+chabb/cgamma))*(rrf+0*btilde) + btilde ;
	      yf = ccy*cf+ciy*invef+gtilde  +  crkky*zcapf ;
	      yf = cfc*( calfa*kf+(1-calfa)*labf +atilde );
	      wf = csigl*labf 	+(1/(1-chabb/cgamma))*cf - (chabb/cgamma)/(1-chabb/cgamma)*cf(-1) ;
	      kpf =  (1-cikbar)*kpf(-1)+(cikbar)*invef + (cikbar)*(cgamma^2*csadjcost)*qstilde ;

// sticky price - wage economy

	      mc =  calfa*rk+(1-calfa)*(w) - 1*atilde - 0*(1-calfa)*atilde ;
	      zcap =  (1/(czcap/(1-czcap)))* rk ;
	      rk =  w+lab-k ;
	      k =  kp(-1)+zcap ;
	      inve = (1/(1+cbetabar*cgamma))* (  inve(-1) + cbetabar*cgamma*inve(1)+(1/(cgamma^2*csadjcost))*pk ) +qstilde ;
          pk = -r+pinf(1)-0*btilde +(1/((1-chabb/cgamma)/(csigma*(1+chabb/cgamma))))*btilde + (crk/(crk+(1-ctou)))*rk(1) +  ((1-ctou)/(crk+(1-ctou)))*pk(1) ;
	      c = (chabb/cgamma)/(1+chabb/cgamma)*c(-1) + (1/(1+chabb/cgamma))*c(+1) +((csigma-1)*cwhlc/(csigma*(1+chabb/cgamma)))*(lab-lab(+1)) - (1-chabb/cgamma)/(csigma*(1+chabb/cgamma))*(r-pinf(+1) + 0*btilde) +btilde ;
	      y = ccy*c+ciy*inve+gtilde  +  1*crkky*zcap ;
	      y = cfc*( calfa*k+(1-calfa)*lab +atilde );
	      pinf =  (1/(1+cbetabar*cgamma*cindp)) * ( cbetabar*cgamma*pinf(1) +cindp*pinf(-1) 
               +((1-cprobp)*(1-cbetabar*cgamma*cprobp)/cprobp)/((cfc-1)*curvp+1)*(mc)  )  + spinftilde ; 
	      w =  (1/(1+cbetabar*cgamma))*w(-1)
               +(cbetabar*cgamma/(1+cbetabar*cgamma))*w(1)
               +(cindw/(1+cbetabar*cgamma))*pinf(-1)
               -(1+cbetabar*cgamma*cindw)/(1+cbetabar*cgamma)*pinf
               +(cbetabar*cgamma)/(1+cbetabar*cgamma)*pinf(1)
               +(1-cprobw)*(1-cbetabar*cgamma*cprobw)/((1+cbetabar*cgamma)*cprobw)*(1/((clandaw-1)*curvw+1))*
               (csigl*lab + (1/(1-chabb/cgamma))*c - ((chabb/cgamma)/(1-chabb/cgamma))*c(-1) -w) 
               + 1*swtilde ;
	      r =  crpi*(1-crr)*pinf
               +cry*(1-crr)*(y-yf)     
               +crdy*(y-yf-y(-1)+yf(-1))
               +crr*r(-1)
               +mstilde  ;
	      a = crhoa*a(-1)  + ea;
	      b = crhob*b(-1) + eb;
	      g = crhog*(g(-1)) + eg + cgy*ea;
	      qs = crhoqs*qs(-1) + eqs;
	      ms = crhoms*ms(-1) + em;
	      spinf = crhopinf*spinf(-1) + epinfma - cmap*epinfma(-1);
	          epinfma=epinf;
	      sw = crhow*sw(-1) + ewma - cmaw*ewma(-1) ;
	          ewma=ew; 
	      kp =  (1-cikbar)*kp(-1)+cikbar*inve + cikbar*cgamma^2*csadjcost*qs ;

          dq  = qtrend + x + eq;
          x   = crhox*x(-1) + ex;

          atilde = a +afactor;
          btilde = b + bfactor;
          gtilde = g + gfactor;
          qstilde = qs + qsfactor;
          mstilde = ms + msfactor;
          spinftilde = spinf + spinffactor;
          swtilde = sw + swfactor;
          f1 = phi11*f1(-1)  + Xi11*ex;
          f2 = phi22*f2(-1)  + Xi12*ex;

          afactor = lambda_a/10*f1 + lambda_a2/10*f2;
          bfactor = lambda_b/10*f1 + lambda_b2/10*f2;
          gfactor = lambda_g/10*f1 + lambda_g2/10*f2;
          qsfactor = lambda_qs/10*f1 + lambda_qs2/10*f2;
          msfactor = lambda_ms/10*f1 + lambda_ms2/10*f2;
          spinffactor = lambda_spinf/10*f1 + lambda_spinf2/10*f2;
          swfactor = lambda_sw/10*f1 + lambda_sw2/10*f2;


// measurment equations

dy=y-y(-1)+ctrend;
dc=c-c(-1)+ctrend;
dinve=inve-inve(-1)+ctrend;
dw=w-w(-1)+ctrend;
pinfobs = 1*(pinf) + constepinf;
robs =    1*(r) + conster;
labobs = lab + constelab;

end; 

shocks;
var ea;
stderr 0.4618;
var eb;
stderr 1.8513;
var eg;
stderr 0.6090;
var eqs;
stderr 0.6017;
var em;
stderr 0.2397;
var epinf;
stderr 0.1455;
var ew;
stderr 0.2089;
var eq;
stderr 0.6500;
var ex;
stderr 0.01;
end;



estimated_params;
// PARAM NAME, INITVAL, LB, UB, PRIOR_SHAPE, PRIOR_P1, PRIOR_P2, PRIOR_P3, PRIOR_P4, JSCALE
// PRIOR_SHAPE: BETA_PDF, GAMMA_PDF, NORMAL_PDF, INV_GAMMA_PDF
stderr ea,0.4618,0.01,3,INV_GAMMA_PDF,0.1,2;
stderr eb,0.1818513,0.025,5,INV_GAMMA_PDF,0.1,2;
stderr eg,0.6090,0.01,3,INV_GAMMA_PDF,0.1,2;
stderr eqs,0.46017,0.01,3,INV_GAMMA_PDF,0.1,2;
stderr em,0.2397,0.01,3,INV_GAMMA_PDF,0.1,2;
stderr epinf,0.1455,0.01,3,INV_GAMMA_PDF,0.1,2;
stderr ew,0.2089,0.01,3,INV_GAMMA_PDF,0.1,2;

/*
crhoa,.9676 ,.01,.9999,BETA_PDF,0.5,0.20;
crhob,.2703,.01,.9999,BETA_PDF,0.5,0.20;
crhog,.9930,.01,.9999,BETA_PDF,0.5,0.20;
crhoqs,.5724,.01,.9999,BETA_PDF,0.5,0.20;
crhoms,.3,.01,.9999,BETA_PDF,0.5,0.20;
crhopinf,.8692,.01,.9999,BETA_PDF,0.5,0.20;
crhow,.9546,.001,.9999,BETA_PDF,0.5,0.20;
cmap,.7652,0.01,.9999,BETA_PDF,0.5,0.2;
cmaw,.8936,0.01,.9999,BETA_PDF,0.5,0.2;
csadjcost,6.3325,2,15,NORMAL_PDF,4,1.5;
csigma,1.2312,0.25,3,NORMAL_PDF,1.50,0.375;
chabb,0.7205,0.001,0.99,BETA_PDF,0.7,0.1;
cprobw,0.7937,0.3,0.95,BETA_PDF,0.5,0.1;
csigl,2.8401,0.25,10,NORMAL_PDF,2,0.75;
cprobp,0.7813,0.5,0.95,BETA_PDF,0.5,0.10;
cindw,0.4425,0.01,0.99,BETA_PDF,0.5,0.15;
cindp,0.3291,0.01,0.99,BETA_PDF,0.5,0.15;
czcap,0.2648,0.01,1,BETA_PDF,0.5,0.15;
cfc,1.4672,1.0,3,NORMAL_PDF,1.25,0.125;
crpi,1.7985,1.0,3,NORMAL_PDF,1.5,0.25;
crr,0.8258,0.5,0.975,BETA_PDF,0.75,0.10;
cry,0.0893,0.001,0.5,NORMAL_PDF,0.125,0.05;
crdy,0.2239,0.001,0.5,NORMAL_PDF,0.125,0.05;
constepinf,0.7,0.1,2.0,GAMMA_PDF,0.625,0.1;//20;
constebeta,0.7420,0.01,2.0,GAMMA_PDF,0.25,0.1;//0.20;
constelab,1.2918,-10.0,10.0,NORMAL_PDF,0.0,2.0;
ctrend,0.3982,0.1,0.8,NORMAL_PDF,0.4,0.10;
cgy,0.05,0.01,2.0,NORMAL_PDF,0.5,0.25;
calfa,0.24,0.01,1.0,NORMAL_PDF,0.3,0.05;
*/
stderr eq,0.20,0.01,3,INV_GAMMA_PDF,0.1,2;
stderr ex,0.20,0.001,3,INV_GAMMA_PDF,0.1,2;
crhox,.90 ,.01,.9999,BETA_PDF,0.5,0.20;
qtrend,0.3982,0.1,0.8,NORMAL_PDF,0.5,0.10;

lambda_a,NORMAL_PDF,0.0,0.05;
lambda_b,NORMAL_PDF,0.0,0.1;
lambda_g,NORMAL_PDF,0.0,0.05;
lambda_qs,NORMAL_PDF,0.0,0.05;
lambda_spinf,NORMAL_PDF,0.0,0.5;
lambda_a2,NORMAL_PDF,0.0,0.05;
lambda_b2,NORMAL_PDF,0.0,0.1;
lambda_g2,NORMAL_PDF,0.0,0.05;
lambda_qs2,NORMAL_PDF,0.0,0.05;
lambda_spinf2,NORMAL_PDF,0.0,0.5;
Xi11, NORMAL_PDF, 0.0, 0.2;
Xi12, NORMAL_PDF, 0.0, 0.2;
phi11, NORMAL_PDF, 0.8, 0.1;
phi22, NORMAL_PDF, 0.8, 0.1;

end;

varobs dy dc dinve labobs pinfobs dw robs dq;

estimation(optim=('MaxIter',200),datafile=usmodel_data_housing,first_obs=1,lik_init=2,prefilter=0,mh_replic=300000,mh_nblocks=1,
mh_jscale=0.30,mh_drop=0.3,order = 1,bayesian_irf,irf = 40) y c inve r pinf w lab dq afactor bfactor gfactor msfactor qsfactor spinffactor swfactor;
//estimation(mode_compute=0,mode_file=usmodel_housing_mode,datafile=usmodel_data_housing,load_mh_file,bayesian_irf,irf_shocks=(eq,ex),order = 1,mh_nblocks=1,mh_jscale=0.30,mh_drop=0.3);
